package com.eactive.eai.batch.job.jobItem.ssnet;

import java.io.ByteArrayOutputStream;
import java.io.File;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.common.StringUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_SSNBT_0600 extends DefaultTelegram implements TelegramService {

    //>> 업무관리정보
    private final String OpCode_start      = "001";    //개별 업무 개시
    private final String OpCode_unit_end   = "002";    //개별업무 종료
    private final String OpCode_end        = "003";    //전체업무 종료

    /**
     * 생성자
     */
    public RECV_SSNBT_0600() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

        //업무관리정보 유효성 확인
        if (this.getOpCode().equalsIgnoreCase(this.OpCode_start)) {
        }
        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_unit_end)) {
        }
        else if(this.getOpCode().equalsIgnoreCase(this.OpCode_end)) {
        }
        else {
            logger.info("{} 0600 telegram : unknown  Operation code received >> "+this.getOpCode(), logHeader);
            this.setResolveResponseCode(TelegramKeys.BOKGG_RES_CODE_ERROR);

            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = this.getOpCode();
            String errCode = "BECEAIFJI008";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            //응답 전문을 수신한 경우에만 return false
        }

        return true;
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * SEND : 송신 길이 계산
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {
        if (idx >= this.getFieldCount()) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            try {
                String byte_size = new String ((byte[]) al_Field.get(0));
                logger.info("{} the sum of definite field length [" + byte_size + "]", logHeader);
                int preLen = 0;
                for (int inx = 1; inx < idx; inx++) {
                    byte[] aField = (byte[]) this.al_Field.get(inx);
                    preLen += aField.length;
                }
                return Integer.parseInt(byte_size) - preLen;
            } catch(Exception e) {
                String[] msgArgs = new String[1];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                String errCode = "BECEAIFJI005";
                String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                logger.error( e.getMessage(), e);
                return -1;
            }
        } else {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
    }

    public boolean doInformalField(int idx, byte[] data, int length)
    {
    	return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
        	batchDoc.getBatchMsg().getBody().setRecvFld01(new String((byte[])this.al_Field.get(1)));
        	batchDoc.getBatchMsg().getBody().setRecvFld05(new String((byte[])this.al_Field.get(5)));
        	batchDoc.getBatchMsg().getBody().setRecvFld06(new String((byte[])this.al_Field.get(6)));
        	batchDoc.getBatchMsg().getBody().setRecvFld07(new String((byte[])this.al_Field.get(7)));
        	batchDoc.getBatchMsg().getBody().setRecvFld08(new String((byte[])this.al_Field.get(8)));
        	batchDoc.getBatchMsg().getBody().setRecvFld09(new String((byte[])this.al_Field.get(9)));
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<5; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));


            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=5; i< al_Field.size(); i++) {
            	baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            String fileDir = batchDoc.getBatchMsg().getHeader().getFilePath();
            String fileNm  = batchDoc.getBatchMsg().getHeader().getFileName();
            if (fileDir.charAt(fileDir.length()-1) != File.separatorChar) {
                fileDir = fileDir + File.separator;
            }
            String fileName = fileDir + fileNm;

            File rcvRealFile = new File( fileName );
            File rcvArchFile = new File( StringUtil.realToArchDir(fileName) );
            File rcvRootFile = new File( StringUtil.realToRootDir(fileName) );

            if ((fileNm != null) && (!fileNm.trim().equals(""))&& (rcvRealFile.exists())) {

                //DB로그에 남길 파일 헤더,트레일러 내용 설정
                super.setFileHeaderAndTrailer(rcvRealFile);

                //DB로그에 남길 변경 파일명 설정 (파일명 변경 안함)
                batchDoc.getBatchMsg().getHeader().setRenamedFileName(fileName);
                //수신 Real 디렉토리 -> Arch 디렉토리로 파일 이동 (파일명 변경 안한고 동일 파일명 존재시 Overwrite)
                logger.info("{} >>>>> 수신 파일을 수신 Real 디렉토리 -> 수신 Arch 디렉토리로 이동.....", logHeader);
                boolean isSuccessMoveFile = rcvRealFile.renameTo(rcvArchFile);
                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI030", new String[] {rcvRealFile.getAbsolutePath(), rcvArchFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 파일을 수신 Real 디렉토리에서 수신 Arch 디렉로 이동시 오류가 발생하였습니다. [Real Path: {1}] [Arch Path: {2}]
                    super.setResolveResponseCode(TelegramKeys.RPS_HDB_RET_CODE_OTHER_ERROR);
                    //수신 파일 End DB로그
                    LogUtil.setLogFileEnd(batchDoc);
                    return true;  //다음단계 수행시 응답코드를 기준으로 에러전문을 송신하기위해 true 설정함
                }

                logger.info("{} >>>>> 수신 파일과 동일 파일명의 0 Byte 파일을 Root 디렉토리에 생성......(HOST에 자동 송신하도록 수신 File Event 발생)", logHeader);
                try {
                    isSuccessMoveFile = rcvRootFile.createNewFile();
                } catch (Exception e) { } // 실패인 경우 무시하고 로깅만 하도록....

                if (!isSuccessMoveFile) {
                    String errMsg = ExceptionUtil.getErrorCode("BECEAIFJI031", new String[] {rcvRootFile.getAbsolutePath()});
                    batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);    //수신 Root 디렉토리에 0 Byte 파일을 생성할 수 없습니다. [Path: {1}]
                }

           }
            //수신 파일 End DB로그
            LogUtil.setLogFileEnd(batchDoc);
            
            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(2);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(3);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(12);
    }
}
